2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by at least coreutils, idutils, CPPI, Bison, and Autoconf.
5 ## Copyright (C) 2001-2008 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Do not save the original name or timestamp in the .tar.gz file.
25 # Use --rsyncable if available.
27 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
28 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
32 VC-tag = git tag -s -m '$(VERSION)'
34 VC_LIST = build-aux/vc-list-files
37 $(VC_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
39 ifeq ($(origin prev_version_file), undefined)
40 prev_version_file = $(srcdir)/.prev-version
43 PREV_VERSION := $(shell cat $(prev_version_file))
44 VERSION_REGEXP = $(subst .,\.,$(VERSION))
45 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
48 this-vc-tag = v$(VERSION)
49 this-vc-tag-regexp = v$(VERSION_REGEXP)
51 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
52 tag-this-version = $(subst .,_,$(VERSION))
53 this-vc-tag = $(tag-package)-$(tag-this-version)
54 this-vc-tag-regexp = $(this-vc-tag)
56 my_distdir = $(PACKAGE)-$(VERSION)
58 # Old releases are stored here.
59 release_archive_dir ?= ../release
61 # Prevent programs like 'sort' from considering distinct strings to be equal.
62 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
71 # Collect the names of rules starting with `sc_'.
72 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
74 .PHONY: $(syntax-check-rules)
76 local-checks-available = \
77 po-check copyright-check m4-check author_mark_check \
78 patch-check strftime-check $(syntax-check-rules) \
79 makefile_path_separator_check \
80 makefile-check check-AUTHORS
81 .PHONY: $(local-checks-available)
83 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
85 syntax-check: $(local-check)
86 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
87 # $$(find -type f -name '*.[chly]') && \
88 # { echo '$(ME): found conditional include' 1>&2; \
91 # grep -nE '^# *include <(string|stdlib)\.h>' \
92 # $(srcdir)/{lib,src}/*.[chy] && \
93 # { echo '$(ME): FIXME' 1>&2; \
95 # FIXME: don't allow `#include .strings\.h' anywhere
97 sc_avoid_if_before_free:
98 @$(srcdir)/build-aux/useless-if-before-free \
99 $(useless_free_options) \
100 $$($(VC_LIST_EXCEPT)) && \
101 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
104 sc_cast_of_argument_to_free:
105 @grep -nE '\<free *\( *\(' $$($(VC_LIST_EXCEPT)) && \
106 { echo '$(ME): don'\''t cast free argument' 1>&2; \
109 sc_cast_of_x_alloc_return_value:
110 @grep -nE '\*\) *x(m|c|re)alloc\>' $$($(VC_LIST_EXCEPT)) && \
111 { echo '$(ME): don'\''t cast x*alloc return value' 1>&2; \
114 sc_cast_of_alloca_return_value:
115 @grep -nE '\*\) *alloca\>' $$($(VC_LIST_EXCEPT)) && \
116 { echo '$(ME): don'\''t cast alloca return value' 1>&2; \
120 @grep -n '[ ] ' $$($(VC_LIST_EXCEPT)) && \
121 { echo '$(ME): found SPACE-TAB sequence; remove the SPACE' \
124 # Don't use *scanf or the old ato* functions in `real' code.
125 # They provide no error checking mechanism.
126 # Instead, use strto* functions.
127 sc_prohibit_atoi_atof:
128 @grep -nE '\<([fs]?scanf|ato([filq]|ll))\>' $$($(VC_LIST_EXCEPT)) && \
129 { echo '$(ME): do not use *scan''f, ato''f, ato''i, ato''l, ato''ll, ato''q, or ss''canf' \
132 # Use STREQ rather than comparing strcmp == 0, or != 0.
134 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
135 $$($(VC_LIST_EXCEPT)) && \
136 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
139 # Using EXIT_SUCCESS as the first argument to error is misleading,
140 # since when that parameter is 0, error does not exit. Use `0' instead.
141 sc_error_exit_success:
142 @grep -nF 'error (EXIT_SUCCESS,' \
143 $$(find -type f -name '*.[chly]') && \
144 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; \
148 @grep -ni 'file''system' $$($(VC_LIST_EXCEPT)) && \
149 { echo '$(ME): found use of "file''system";' \
150 'rewrite to use "file system"' 1>&2; \
153 # Don't use cpp tests of this symbol. All code assumes config.h is included.
155 @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) && \
156 { echo '$(ME): found use of HAVE''_CONFIG_H; remove' \
159 # Nearly all .c files must include <config.h>.
161 @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
162 grep -L '^# *include <config\.h>' \
163 $$($(VC_LIST_EXCEPT) | grep '\.c$$') \
165 { echo '$(ME): the above files do not include <config.h>' \
166 1>&2; exit 1; } || :; \
170 # To use this "command" macro, you must first define two shell variables:
171 # h: the header, enclosed in <> or ""
172 # re: a regular expression that matches IFF something provided by $h is used.
173 define _header_without_use
174 h_esc=`echo "$$h"|sed 's/\./\\./'`; \
175 if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
176 files=$$(grep -l '^# *include '"$$h_esc" \
177 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
178 grep -LE "$$re" $$files | grep . && \
179 { echo "$(ME): the above files include $$h but don't use it" \
180 1>&2; exit 1; } || :; \
185 # Prohibit the inclusion of assert.h without an actual use of assert.
186 sc_prohibit_assert_without_use:
187 @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
189 # Prohibit the inclusion of getopt.h without an actual use.
190 sc_prohibit_getopt_without_use:
191 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
193 # Don't include quotearg.h unless you use one of its functions.
194 sc_prohibit_quotearg_without_use:
195 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
197 # Don't include quote.h unless you use one of its functions.
198 sc_prohibit_quote_without_use:
199 @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
201 # Don't include this header unless you use one of its functions.
202 sc_prohibit_long_options_without_use:
203 @h='"long-options.h"' re='\<parse_long_options *\(' \
204 $(_header_without_use)
206 # Don't include this header unless you use one of its functions.
207 sc_prohibit_inttostr_without_use:
208 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
209 $(_header_without_use)
211 # Don't include this header unless you use one of its functions.
212 sc_prohibit_error_without_use:
214 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
215 $(_header_without_use)
217 sc_prohibit_safe_read_without_use:
218 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
219 $(_header_without_use)
221 sc_prohibit_argmatch_without_use:
223 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
224 $(_header_without_use)
226 sc_prohibit_root_dev_ino_without_use:
227 @h='"root-dev-ino.h"' \
228 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
229 $(_header_without_use)
232 @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
233 $$($(VC_LIST_EXCEPT)) && \
234 { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY' \
237 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
239 # Each nonempty line must start with a year number, or a TAB.
241 @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) && \
242 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
245 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
246 # with the strings from the two affected variables.
247 dd_c = $(srcdir)/src/dd.c
248 sc_dd_max_sym_length:
249 ifneq ($(wildcard $(dd_c)),)
250 @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
251 sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) ) \
252 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p' \
253 | wc --max-line-length); \
254 max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
255 |tr -d '"' | wc --max-line-length); \
256 if test "$$len" = "$$max"; then :; else \
257 echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2; \
262 # Many m4 macros names once began with `jm_'.
263 # On 2004-04-13, they were all changed to start with gl_ instead.
264 # Make sure that none are inadvertently reintroduced.
265 sc_prohibit_jm_in_m4:
266 @grep -nE 'jm_[A-Z]' \
267 $$($(VC_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
268 { echo '$(ME): do not use jm_ in m4 macro names' \
271 # Ensure that each root-requiring test is run via the "check-root" rule.
274 && grep check-root tests/Makefile.am>/dev/null 2>&1; then \
275 t1=sc-root.expected; t2=sc-root.actual; \
276 grep -nl '^require_root_$$' \
277 $$($(VC_LIST) tests) |sed s,tests/,, |sort > $$t1; \
278 sed -n '/^root_tests =[ ]*\\$$/,/[^\]$$/p' \
279 $(srcdir)/tests/Makefile.am \
280 | sed 's/^ *//;/^root_tests =/d' \
281 | tr -s '\012\\' ' ' | fmt -1 | sort > $$t2; \
282 diff -u $$t1 $$t2 || diff=1; \
285 && { echo 'tests/Makefile.am: missing check-root action'>&2; \
289 headers_with_interesting_macro_defs = \
300 # Create a list of regular expressions matching the names
301 # of macros that are guaranteed by parts of gnulib to be defined.
303 @(cd $(srcdir)/lib; \
304 for f in $(headers_with_interesting_macro_defs); do \
306 sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f; \
309 | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX' \
310 | sed 's/^/^# *define /' \
314 # Don't define macros that we already get from gnulib header files.
315 sc_always_defined_macros: .re-defmac
316 @if test -f $(srcdir)/src/system.h; then \
317 trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15; \
318 grep -f .re-defmac $$($(VC_LIST)) \
319 && { echo '$(ME): define the above via some gnulib .h file' \
320 1>&2; exit 1; } || :; \
323 # Create a list of regular expressions matching the names
324 # of files included from system.h. Exclude a couple.
326 @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
327 | grep -Ev 'sys/(param|file)\.h' \
328 | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
332 # Files in src/ should not include directly any of
333 # the headers already included via system.h.
334 sc_system_h_headers: .re-list
335 @if test -f $(srcdir)/src/system.h; then \
336 trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15; \
337 grep -nE -f .re-list \
338 $$($(VC_LIST) src | \
339 grep -Ev '((copy|system)\.h|parse-gram\.c)$$') \
340 && { echo '$(ME): the above are already included via system.h'\
341 1>&2; exit 1; } || :; \
344 # Ensure that each .c file containing a "main" function also
345 # declares "char *program_name", with or without "const".
347 @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
348 files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
349 grep -EL '^(char const|(const )?char) \*program_name;' $$files \
351 { echo '$(ME): the above files do not declare program_name' \
352 1>&2; exit 1; } || :; \
356 # Require that the final line of each test-lib.sh-using test be this one:
357 # (exit $fail); exit $fail
358 # Note: this test requires GNU grep's --label= option.
359 sc_require_test_exit_idiom:
360 @if test -f $(srcdir)/tests/test-lib.sh; then \
362 for i in $$(grep -l -F /../test-lib.sh $$($(VC_LIST) tests)); do \
363 tail -n1 $$i | grep '^(exit \$$fail); exit \$$fail$$' > /dev/null \
364 && : || { die=1; echo $$i; } \
367 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
368 echo 1>&2 '(exit $$fail); exit $$fail'; \
374 'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
375 $$($(VC_LIST_EXCEPT)) && \
376 { echo '$(ME): found misuse of Sun OS version numbers' 1>&2; \
380 @grep -ni '\<the ''the\>' $$($(VC_LIST_EXCEPT)) && \
381 { echo '$(ME): found use of "the ''the";' 1>&2; \
388 @grep -n '[ ]$$' $$($(VC_LIST_EXCEPT)) && \
389 { echo '$(ME): found trailing blank(s)' \
392 # Match lines like the following, but where there is only one space
393 # between the options and the description:
394 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
395 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
396 sc_two_space_separator_in_usage:
397 @grep -nE '^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
398 $$($(VC_LIST_EXCEPT)) && \
399 { echo "$(ME): help2man requires at least two spaces between"; \
400 echo "$(ME): an option and its description"; \
403 # Look for diagnostics that aren't marked for translation.
404 # This won't find any for which error's format string is on a separate line.
405 sc_unmarked_diagnostics:
407 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
408 | grep -v '_''(' && \
409 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
412 # Avoid useless parentheses like those in this example:
413 # #if defined (SYMBOL) || defined (SYM2)
414 sc_useless_cpp_parens:
415 @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) && \
416 { echo '$(ME): found useless parentheses in cpp directive' \
419 # Require the latest GPL.
421 @grep -n 'either ''version [^3]' $$($(VC_LIST_EXCEPT)) && \
422 { echo '$(ME): GPL vN, N!=3' 1>&2; exit 1; } || :
425 exec \$$PERL -w -I\$$top_srcdir/tests -MCoreutils \
426 -M"CuTmpdir qw(\$$me)" -- - <<\\EOF
427 # Ensure that each test invoking $PERL with -MCoreutils uses the same line.
428 sc_perl_coreutils_test:
429 @if test -f $(srcdir)/tests/Coreutils.pm; then \
431 for i in $$(grep -l '^exec *\$$PERL.*MCoreutils' \
432 $$($(VC_LIST) tests)); do \
433 grep '$(exec_perl_re)' $$i > /dev/null \
434 && : || { die=1; echo $$i; } \
437 { echo 1>&2 '$(ME): each of the above execs PERL differently:'; \
438 echo 1>&2 '(exit $$fail); exit $$fail'; \
443 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
444 $(srcdir)/NEWS | md5sum -)
446 # Ensure that we don't accidentally insert an entry into an old NEWS block.
448 @if test -f $(srcdir)/NEWS; then \
449 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
450 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
453 # Update the hash stored above. Do this after each release and
454 # for any corrections to old entries.
455 update-NEWS-hash: NEWS
456 perl -pi -e 's/^(old_NEWS_hash = ).*/$${1}'"$(NEWS_hash)/" \
459 # Ensure that the c99-to-c89 patch applies cleanly.
461 rm -rf src-c89 $@.1 $@.2
463 (cd src-c89; patch -p1 -V never --fuzz=0) < src/c99-to-c89.diff \
465 if test "$$REGEN_PATCH" = yes; then \
466 diff -upr src src-c89 | sed 's,src-c89/,src/,' \
467 | grep -v '^Only in' > new-diff || : ; fi
468 grep -v '^patching file ' $@.1 > $@.2 || :
469 msg=ok; test -s $@.2 && msg='fuzzy patch' || : ; \
470 rm -f src-c89/*.o || msg='rm failed'; \
471 $(MAKE) -C src-c89 CFLAGS='-Wdeclaration-after-statement -Werror' \
472 || msg='compile failure with extra options'; \
473 test "$$msg" = ok && rm -rf src-c89 $@.1 $@.2 || echo "$$msg" 1>&2; \
476 # Ensure that date's --help output stays in sync with the info
477 # documentation for GNU strftime. The only exception is %N,
478 # which date accepts but GNU strftime does not.
479 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
481 if test -f $(srcdir)/src/date.c; then \
482 grep '^ %. ' $(srcdir)/src/date.c | sort \
483 | $(extract_char) > $@-src; \
485 info libc date calendar format | grep '^ `%.'\' \
486 | $(extract_char); } | sort > $@-info; \
487 diff -u $@-src $@-info || exit 1; \
488 rm -f $@-src $@-info; \
494 # Ensure that we use only the standard $(VAR) notation,
495 # not @...@ in Makefile.am, now that we can rely on automake
496 # to emit a definition for each substituted variable.
498 grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
499 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
501 news-date-check: NEWS
502 today=`date +%Y-%m-%d`; \
503 if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
507 echo "version or today's date is not in NEWS" 1>&2; \
512 if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
516 echo "$(VERSION) not in ChangeLog" 1>&2; \
521 @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
522 && { echo '$(ME): quote the first arg to AC_DEFUN' 1>&2; \
525 # Verify that all source files using _() are listed in po/POTFILES.in.
526 # FIXME: don't hard-code file names below; use a more general mechanism.
528 if test -f po/POTFILES.in; then \
529 grep -E -v '^(#|$$)' po/POTFILES.in \
530 | grep -v '^src/false\.c$$' | sort > $@-1; \
532 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
534 djgpp/* | man/*) continue;; \
535 */c99-to-c89.diff) continue;; \
539 base=`expr " $$file" : ' \(.*\)\..'`; \
540 { test -f $$base.l || test -f $$base.y; } && continue;; \
542 files="$$files $$file"; \
544 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
546 diff -u $@-1 $@-2 || exit 1; \
550 # In a definition of #define AUTHORS "... and ..." where the RHS contains
551 # the English word `and', the string must be marked with `N_ (...)' so that
552 # gettext recognizes it as a string requiring translation.
554 @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
555 { echo '$(ME): enclose the above strings in N_ (...)' 1>&2; \
558 # Sometimes it is useful to change the PATH environment variable
559 # in Makefiles. When doing so, it's better not to use the Unix-centric
560 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
561 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
562 # and there probably aren't many projects with so many Makefile.am files
563 # that we'd have to worry about limits on command line length.
564 msg = '$(ME): Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
565 makefile_path_separator_check:
566 @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
567 && { echo $(msg) 1>&2; exit 1; } || :
569 # Check that `make alpha' will not fail at the end of the process.
571 if test -d $(release_archive_dir); then :; else \
572 for file in $(distdir).tar.gz \
573 $(release_archive_dir)/$(distdir).tar.gz; do \
574 test -e $$file || continue; \
576 || { echo ERROR: $$file is not writable; fail=1; }; \
578 test "$$fail" && exit 1 || : ; \
581 v_etc_file = lib/version-etc.c
582 sample-test = tests/sample-test
583 texi = doc/$(PACKAGE).texi
584 # Make sure that the copyright date in $(v_etc_file) is up to date.
585 # Do the same for the $(sample-test) and the main doc/.texi file.
587 @if test -f $(v_etc_file); then \
588 grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
590 || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
593 @if test -f $(sample-test); then \
594 grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test) \
596 || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
599 @if test -f $(texi); then \
600 grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi) \
602 || { echo 'out of date copyright in $(texi); update it' 1>&2; \
607 $(VC) diff > vc-diffs || :
608 if test -s vc-diffs; then \
610 echo "Some files are locally modified:" 1>&2; \
616 cvs-check: vc-diff-check
618 maintainer-distcheck:
623 # Don't make a distribution if checks fail.
624 # Also, make sure the NEWS file is up-to-date.
625 vc-dist: $(local-check) cvs-check maintainer-distcheck
628 # Use this to make sure we don't run these programs when building
629 # from a virgin tgz file, below.
630 null_AM_MAKEFLAGS = \
637 built_programs = $$(cd src && MAKEFLAGS= $(MAKE) -s built_programs.list)
639 warn_cflags = -Dlint -O -Werror -Wall -Wformat -Wshadow -Wpointer-arith
642 write_loser = printf '\#!%s\necho $$0: bad path 1>&2; exit 1\n' '$(SHELL)'
645 t=$(TMPDIR)/$(PACKAGE)/test
648 # Verify that a twisted use of --program-transform-name=PROGRAM works.
649 define install-transform-check
651 $(MAKE) program_transform_name='s/.*/zyx/' \
652 prefix=$(pfx) install \
653 && test "$$(echo $(pfx)/bin/*)" = "$(pfx)/bin/zyx" \
654 && test "$$(echo $(pfx)/share/man/man1/*)" = \
655 "$(pfx)/share/man/man1/zyx.1"
658 # Install, then verify that all binaries and man pages are in place.
659 # Note that neither the binary, ginstall, nor the ].1 man page is installed.
661 $(MAKE) prefix=$(pfx) install \
662 && test ! -f $(pfx)/bin/ginstall \
664 for i in $(built_programs); do \
665 test "$$i" = ginstall && i=install; \
666 for j in "$(pfx)/bin/$$i" \
667 "$(pfx)/share/man/man1/$$i.1"; do \
668 case $$j in *'[.1') continue;; esac; \
670 || { echo "$$j not installed"; fail=1; }; \
673 test $$fail = 1 && exit 1 || :; \
677 # Use -Wformat -Werror to detect format-string/arg-list mismatches.
678 # Also, check for shadowing problems with -Wshadow, and for pointer
679 # arithmetic problems with -Wpointer-arith.
680 # These CFLAGS are pretty strict. If you build this target, you probably
681 # have to have a recent version of gcc and glibc headers.
682 # The hard-linking for-loop below ensures that there is a bin/ directory
683 # full of all of the programs under test (except the ones that are required
684 # for basic Makefile rules), all symlinked to the just-built "false" program.
685 # This is to ensure that if ever a test neglects to make PATH include
686 # the build srcdir, these always-failing programs will run.
687 # Otherwise, it is too easy to test the wrong programs.
688 # Note that "false" itself is a symlink to true, so it too will malfunction.
689 my-distcheck: $(DIST_ARCHIVES) $(local-check) check
692 GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
694 && ./configure --disable-nls \
695 && $(MAKE) CFLAGS='$(warn_cflags)' \
696 AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)' \
698 && $(install-transform-check) \
701 && ($(write_loser)) > $(bin)/loser \
702 && chmod a+x $(bin)/loser \
703 && for i in $(built_programs); do \
705 rm|expr|basename|echo|sort|ls|tr);; \
706 cat|dirname|mv|wc);; \
707 *) ln $(bin)/loser $(bin)/$$i;; \
710 && ln -sf ../src/true $(bin)/false \
711 && PATH=`pwd`/$(bin):$$PATH $(MAKE) -C tests check \
712 && { test -d gnulib-tests \
713 && $(MAKE) -C gnulib-tests check \
717 (cd $(t) && mv $(distdir) $(distdir).old \
718 && $(AMTAR) -zxf - ) < $(distdir).tar.gz
719 diff -ur $(t)/$(distdir).old $(t)/$(distdir)
720 if test -f $(srcdir)/src/c99-to-c89.diff; then \
722 && (cd src && patch -V never --fuzz=0 <c99-to-c89.diff) \
723 && ./configure --disable-largefile \
724 CFLAGS='-Werror -ansi -Wno-long-long' \
728 @echo "========================"; \
729 echo "$(distdir).tar.gz is ready for distribution"; \
730 echo "========================"
736 tarz=/tmp/rel-check-tarz-$$$$; \
737 md5_tmp=/tmp/rel-check-md5-$$$$; \
739 trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
740 $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
741 echo "$(md5) -" > $$md5_tmp; \
742 md5sum -c $$md5_tmp < $$tarz
744 rel-files = $(DIST_ARCHIVES)
746 gnulib-version = $$(cd $(gnulib_dir) && git describe)
748 announcement: NEWS ChangeLog $(rel-files)
749 @./build-aux/announce-gen \
750 --release-type=$(RELEASE_TYPE) \
751 --package=$(PACKAGE) \
752 --prev=$(PREV_VERSION) \
754 --gpg-key-id=$(gpg_key_ID) \
756 --bootstrap-tools=autoconf,automake,bison,gnulib \
757 --gnulib-version=$(gnulib-version) \
758 $(addprefix --url-dir=, $(url_dir_list))
760 ## ---------------- ##
761 ## Updating files. ##
762 ## ---------------- ##
764 ftp-gnu = ftp://ftp.gnu.org/gnu
765 www-gnu = http://www.gnu.org
767 # Use mv, if you don't have/want move-if-change.
768 move_if_change ?= move-if-change
770 emit_upload_commands:
771 @echo =====================================
772 @echo =====================================
773 @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
774 @echo " --to $(gnu_rel_host):$(PACKAGE) \\"
775 @echo " $(rel-files)"
776 @echo '# send the /tmp/announcement e-mail'
777 @echo =====================================
778 @echo =====================================
780 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
781 define emit-commit-log
782 printf '%s\n' 'post-release administrivia' '' \
783 '* NEWS: Add header line for next release.' \
784 '* .prev-version: Record previous version.' \
785 '* cfg.mk (old_NEWS_hash): Auto-update.'
788 .PHONY: alpha beta major
789 alpha beta major: $(local-check) writable-files
791 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
792 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
795 $(MAKE) news-date-check
796 $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
797 if test -d $(release_archive_dir); then \
798 ln $(rel-files) $(release_archive_dir); \
799 chmod a-w $(rel-files); \
801 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
802 echo $(VERSION) > $(prev_version_file)
803 $(MAKE) update-NEWS-hash
804 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
805 $(emit-commit-log) > .ci-msg
806 $(VC) commit -F .ci-msg